const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Domain_mappingsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const domain_mappings = await db.domain_mappings.create(
      {
        id: data.id || undefined,

        domain: data.domain || null,
        status: data.status || null,
        verification_token: data.verification_token || null,
        ssl_status: data.ssl_status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await domain_mappings.setUser(data.user || null, {
      transaction,
    });

    await domain_mappings.setProfile_page(data.profile_page || null, {
      transaction,
    });

    await domain_mappings.setOrganizations(data.organizations || null, {
      transaction,
    });

    return domain_mappings;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const domain_mappingsData = data.map((item, index) => ({
      id: item.id || undefined,

      domain: item.domain || null,
      status: item.status || null,
      verification_token: item.verification_token || null,
      ssl_status: item.ssl_status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const domain_mappings = await db.domain_mappings.bulkCreate(
      domain_mappingsData,
      { transaction },
    );

    // For each item created, replace relation files

    return domain_mappings;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const domain_mappings = await db.domain_mappings.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.domain !== undefined) updatePayload.domain = data.domain;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.verification_token !== undefined)
      updatePayload.verification_token = data.verification_token;

    if (data.ssl_status !== undefined)
      updatePayload.ssl_status = data.ssl_status;

    updatePayload.updatedById = currentUser.id;

    await domain_mappings.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await domain_mappings.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.profile_page !== undefined) {
      await domain_mappings.setProfile_page(
        data.profile_page,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await domain_mappings.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return domain_mappings;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const domain_mappings = await db.domain_mappings.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of domain_mappings) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of domain_mappings) {
        await record.destroy({ transaction });
      }
    });

    return domain_mappings;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const domain_mappings = await db.domain_mappings.findByPk(id, options);

    await domain_mappings.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await domain_mappings.destroy({
      transaction,
    });

    return domain_mappings;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const domain_mappings = await db.domain_mappings.findOne(
      { where },
      { transaction },
    );

    if (!domain_mappings) {
      return domain_mappings;
    }

    const output = domain_mappings.get({ plain: true });

    output.user = await domain_mappings.getUser({
      transaction,
    });

    output.profile_page = await domain_mappings.getProfile_page({
      transaction,
    });

    output.organizations = await domain_mappings.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.profile_pages,
        as: 'profile_page',

        where: filter.profile_page
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.profile_page
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.profile_page
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.domain) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('domain_mappings', 'domain', filter.domain),
        };
      }

      if (filter.verification_token) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'domain_mappings',
            'verification_token',
            filter.verification_token,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.ssl_status) {
        where = {
          ...where,
          ssl_status: filter.ssl_status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.domain_mappings.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('domain_mappings', 'domain', query),
        ],
      };
    }

    const records = await db.domain_mappings.findAll({
      attributes: ['id', 'domain'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['domain', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.domain,
    }));
  }
};
